<script setup>

import { ref, onMounted, inject, useTemplateRef } from 'vue';
import { Switch } from '@cloudron/pankow';
import SaveIndicator from '../components/SaveIndicator.vue';
import Section from '../components/Section.vue';
import SettingsItem from '../components/SettingsItem.vue';
import UserDirectoryModel from '../models/UserDirectoryModel.js';

const features = inject('features');

const userDirectoryModel = UserDirectoryModel.create();

const busy = ref(false);
const mandatory2FA = ref(false);
const mandatory2FASaveIndicator = useTemplateRef('mandatory2FASaveIndicator');

async function onToggleMandatory2FA(value) {
  busy.value = true;

  const [error] = await userDirectoryModel.setGlobalProfileConfig({ mandatory2FA: value, lockUserProfiles: !editableUserProfiles.value });
  if (error) {
    mandatory2FA.value = !value;
    mandatory2FASaveIndicator.value.error();
    console.error(error);
  } else {
    mandatory2FASaveIndicator.value.success();
  }

  busy.value = false;
}

const editableUserProfiles = ref(false);
const editableUserProfilesSaveIndicator = useTemplateRef('editableUserProfilesSaveIndicator');

async function onToggleEditableUserProfiles(value) {
  busy.value = true;

  const [error] = await userDirectoryModel.setGlobalProfileConfig({ mandatory2FA: mandatory2FA.value, lockUserProfiles: !value });
  if (error) {
    editableUserProfiles.value = !value;
    editableUserProfilesSaveIndicator.value.error();
    console.error(error);
  } else {
    editableUserProfilesSaveIndicator.value.success();
  }

  busy.value = false;
}

onMounted(async () => {
  const [error, result] = await userDirectoryModel.getGlobalProfileConfig();
  if (error) return console.error(error);

  editableUserProfiles.value = !result.lockUserProfiles;
  mandatory2FA.value = result.mandatory2FA;
});

</script>

<template>
  <div class="content">
    <Section :title="$t('users.settings.title')" :title-badge="!features.profileConfig ? 'Upgrade' : ''">
      <SettingsItem>
        <div>{{ $t('users.settings.allowProfileEditCheckbox') }} <sup><a href="https://docs.cloudron.io/user-directory/#lock-profile" target="_blank"><i class="fa fa-question-circle"></i></a></sup></div>
        <Switch v-model="editableUserProfiles" @change="onToggleEditableUserProfiles" :disabled="busy || !features.profileConfig"/>
        <SaveIndicator ref="editableUserProfilesSaveIndicator"/>
      </SettingsItem>

      <SettingsItem>
        <div>{{ $t('users.settings.require2FACheckbox') }}</div>
        <Switch v-model="mandatory2FA" @change="onToggleMandatory2FA" :disabled="busy || !features.profileConfig"/>
        <SaveIndicator ref="mandatory2FASaveIndicator"/>
      </SettingsItem>
    </Section>
  </div>
</template>
